<?xml version="1.0" encoding="UTF-8"?>
<TmoConfig>
    <AlgoControl name="tmo">
        <!-- TMO算法开关，0为打开，1为bypass -->
        <bypass>0</bypass>
        <!-- TMO 计算模式选择(互斥) -->
        <!--   0      1   -->
        <!--  HSV   CAM02 -->
        <calculationMode>0</calculationMode>
        <!-- TMO生效模式白名单，0为不生效，1为生效 -->
        <enableMode>
            <capture>0</capture> <!-- 普通拍照 -->
            <video>1</video> <!-- 普通视频 -->
            <frontCam>0</frontCam> <!-- 前置模式 -->
            <displayCam>1</displayCam> <!-- 仅送显路 -->
        </enableMode>
    </AlgoControl>

    <HsvCalculationParams>
        <!-- HSV色相调整开关，0为不调整，1为调整 -->
        <hueBiasControl>0</hueBiasControl>
        <!-- HSV明度调整开关，0为不调整，1为调整 -->
        <valAdjControl>1</valAdjControl>
        <!-- TMO调整强度，接受 0至100整数 -->
        <weightControl>
            <red>20</red>
            <yellow>100</yellow>
            <green>100</green>
            <cyan>100</cyan>
            <blue>100</blue>
            <magenta>100</magenta>
        </weightControl>
        <!-- GTM过渡范围，低收益下动态关闭TMO以降低算法功耗 -->
        <gtmIntensityThreshold>
            <lowerThreshold>400</lowerThreshold>
            <upperThreshold>1000</upperThreshold>
        </gtmIntensityThreshold>
        <!-- 不同色相区域分亮度控制TMO强度，1代表能达到所设定的全局强度, 接受 0 ~ 1 浮点数 -->
        <lumaHueControl>
            <!--对应亮度格点：0, 64, 128, 192, 256, 320, 384, 448, 512, 576, 640, 704, 768, 832, 896, 960, 1023-->
            <redLuma>0, 0, 0, 0.2, 0.4, 0.6, 0.8, 1, 1, 1, 1, 0.8, 0.6, 0.4, 0.2, 0, 0</redLuma>
            <yellowLuma>0, 0, 0, 0.2, 0.4, 0.6, 0.8, 1, 1, 1, 1, 0.8, 0.6, 0.4, 0.2, 0, 0</yellowLuma>
            <greenLuma>0, 0, 0, 0.2, 0.4, 0.6, 0.8, 1, 1, 1, 1, 0.8, 0.6, 0.4, 0.2, 0, 0</greenLuma>
            <cyanLuma>0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0.8, 0.6, 0.4, 0.2, 0, 0</cyanLuma>
            <blueLuma>0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0.8, 0.6, 0.4, 0.2, 0, 0</blueLuma>
            <magentaLuma>0, 0, 0, 0.2, 0.4, 0.6, 0.8, 1, 1, 1, 1, 0.8, 0.6, 0.4, 0.2, 0, 0</magentaLuma>
        </lumaHueControl>
        <!-- 不同色相区域分饱和度控制TMO程度，主要用于高饱和度保护，1代表能达到所设定的全局强度, 接受 0 ~ 1 浮点数 -->
        <satHueControl>
            <!--对应饱和度格点：0, 64, 128, 192, 256, 320, 384, 448, 512, 576, 640, 704, 768, 832, 896, 960, 1023-->
            <redSat>0, 0, 0, 0.3, 0.6, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0</redSat>
            <yellowSat>0, 0, 0, 0.3, 0.6, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0</yellowSat>
            <greenSat>0, 0, 0, 0.3, 0.6, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0, 0, 0</greenSat>
            <cyanSat>0, 0, 0, 0.3, 0.6, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0, 0, 0</cyanSat>
            <blueSat>0, 0, 0, 0.3, 0.6, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0, 0, 0</blueSat>
            <magentaSat>0, 0, 0, 0.3, 0.6, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0, 0, 0</magentaSat>
        </satHueControl>
        <!-- 不同亮度区域分色相添加亮度，主要用于DRC提升对比度后颜色还原，1为最大值, 接受 0 ~ 1 浮点数 -->
        <hueValueControl>
            <!--对应亮度格点：0, 64, 128, 192, 256, 320, 384, 448, 512, 576, 640, 704, 768, 832, 896, 960, 1023-->
            <redVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.2, 0.2, 0.2, 0.2, 0.1, 0, 0, 0, 0</redVal>
            <yellowVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.2, 0.2, 0.2, 0.1, 0.1, 0, 0, 0, 0</yellowVal>
            <greenVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.4, 0.4, 0.3, 0.1, 0.0, 0, 0, 0</greenVal>
            <cyanVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.4, 0.3, 0.2, 0.1, 0, 0, 0, 0</cyanVal>
            <blueVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.4, 0.3, 0.2, 0.1, 0, 0, 0, 0</blueVal>
            <magentaVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.2, 0.2, 0.2, 0.1, 0.1, 0, 0, 0, 0</magentaVal>
        </hueValueControl>
        <!-- 不同饱和度区域分色相添加亮度，主要用于DRC提升对比度后颜色还原，1为最大值, 接受 0 ~ 1 浮点数 -->
        <satValueControl>
            <!--对应饱和度格点：0, 64, 128, 192, 256, 320, 384, 448, 512, 576, 640, 704, 768, 832, 896, 960, 1023-->
            <redVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.3, 0.3, 0.2, 0.1, 0.0, 0, 0, 0</redVal>
            <yellowVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.3, 0.3, 0.2, 0.1, 0.0, 0, 0, 0</yellowVal>
            <greenVal>0, 0, 0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.3, 0.3, 0.3, 0.1, 0.0, 0, 0, 0</greenVal>
            <cyanVal>0, 0, 0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.3, 0.3, 0.2, 0.1, 0.0, 0, 0, 0</cyanVal>
            <blueVal>0, 0, 0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.3, 0.3, 0.2, 0.1, 0.0, 0, 0, 0</blueVal>
            <magentaVal>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.2, 0.3, 0.3, 0.3, 0.2, 0.1, 0.0, 0, 0, 0</magentaVal>
        </satValueControl>
    </HsvCalculationParams>

    <CAM02CalculationParams>
        <!-- JCH计算触发阈值，取决于gamma变化幅度，gamma变化较弱时动态关闭以降低功耗，接受非负整数 -->
        <triggerThreshold>600</triggerThreshold>
        <!-- 色调补偿表，以30°为间隔设置，中间值插值得到，接受正负浮点数 -->
        <hueShift>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0</hueShift>
        <!-- 彩度控制表 -->
        <chromaControl>
            <!-- 彩度基础权重，接受 0 ~ 1 浮点数 -->
            <base>1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0</base>
            <!-- 彩度附加权重，接受 -1 ~ 1 浮点数 -->
            <addition>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0</addition>
            <!-- 低饱和度区域调节幅度衰减系数，接受 -1 ~ 0 浮点数 -->
            <attenuation>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0</attenuation>
        </chromaControl>
    </CAM02CalculationParams>
</TmoConfig>
